﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class makeDonation : System.Web.UI.Page
    {
        protected const string operation = "makeDonation";

        protected string Data
        {
            get
            {
                return                                      "api_key="                  + HttpUtility.UrlEncode(txt_api_key.Text)                   +
                    (txt_user_id.Text               != "" ? "&user_id="                 + HttpUtility.UrlEncode(txt_user_id.Text)                   : "") +
                    (txt_tribute_id.Text            != "" ? "&tribute_id="              + HttpUtility.UrlEncode(txt_tribute_id.Text)                : "") +
                                                            "&donation_online="         + chk_donation_online.Checked                               +
                                                            "&anonymous="               + chk_anonymous.Checked                                     +
                                                            "&anonymous_report="        + chk_anonymous_report.Checked                              +
                    (txt_display_name.Text          != "" ? "&display_name="            + HttpUtility.UrlEncode(txt_display_name.Text)              : "") +
                    (txt_message.Text               != "" ? "&message="                 + HttpUtility.UrlEncode(txt_message.Text)                   : "") +
                    (txt_email.Text                 != "" ? "&email="                   + HttpUtility.UrlEncode(txt_email.Text)                     : "") +
                    (txt_ip.Text                    != "" ? "&ip="                      + HttpUtility.UrlEncode(txt_ip.Text)                        : "") +
                    (txt_donation.Text              != "" ? "&donation="                + HttpUtility.UrlEncode(txt_donation.Text)                  : "") +
                                                            "&hide_donation_value="     + chk_hide_donation_value.Checked                           +
                                                            "&gift_aid="                + chk_gift_aid.Checked                                      +
                    (txt_first_name.Text            != "" ? "&first_name="              + HttpUtility.UrlEncode(txt_first_name.Text)                : "") +
                    (txt_last_name.Text             != "" ? "&last_name="               + HttpUtility.UrlEncode(txt_last_name.Text)                 : "") +
                    (txt_address1.Text              != "" ? "&address1="                + HttpUtility.UrlEncode(txt_address1.Text)                  : "") +
                    (txt_address2.Text              != "" ? "&address2="                + HttpUtility.UrlEncode(txt_address2.Text)                  : "") +
                    (txt_town.Text                  != "" ? "&town="                    + HttpUtility.UrlEncode(txt_town.Text)                      : "") +
                                                            "&overseas="                + chk_overseas.Checked                                      +
                    (txt_post_code.Text             != "" ? "&post_code="               + HttpUtility.UrlEncode(txt_post_code.Text)                 : "") +
                    (ddl_payment_type.SelectedValue != "" ? "&payment_type="            + HttpUtility.UrlEncode(ddl_payment_type.SelectedValue)     : "") +
                                                            "&accept_t_c="              + chk_accept_t_c.Checked                                    +
                    (txt_successfulReturnURL.Text   != "" ? "&successfulReturnURL="     + HttpUtility.UrlEncode(txt_successfulReturnURL.Text)       : "") +
                    (txt_unsuccessfulReturnURL.Text != "" ? "&unsuccessfulReturnURL="   + HttpUtility.UrlEncode(txt_unsuccessfulReturnURL.Text)     : "");
            }
        }

        protected string SOAPData
        {
            get
            {
                return                                      "<api_key>"                 + txt_api_key.Text                  + "</api_key>"                  +
                    (txt_user_id.Text               != "" ? "<user_id>"                 + txt_user_id.Text                  + "</user_id>"                  : "") +
                    (txt_tribute_id.Text            != "" ? "<tribute_id>"              + txt_tribute_id.Text               + "</tribute_id>"               : "") +
                                                            "<donation_online>"         + chk_donation_online.Checked       + "</donation_online>"          +
                                                            "<anonymous>"               + chk_anonymous.Checked             + "</anonymous>"                +
                                                            "<anonymous_report>"        + chk_anonymous_report.Checked      + "</anonymous_report>"         +
                    (txt_display_name.Text          != "" ? "<display_name>"            + txt_display_name.Text             + "</display_name>"             : "") +
                    (txt_message.Text               != "" ? "<message>"                 + txt_message.Text                  + "</message>"                  : "") +
                    (txt_email.Text                 != "" ? "<email>"                   + txt_email.Text                    + "</email>"                    : "") +
                    (txt_ip.Text                    != "" ? "<ip>"                      + txt_ip.Text                       + "</ip>"                       : "") +
                    (txt_donation.Text              != "" ? "<donation>"                + txt_donation.Text                 + "</donation>"                 : "") +
                                                            "<hide_donation_value>"     + chk_hide_donation_value.Checked   + "</hide_donation_value>"      +
                                                            "<gift_aid>"                + chk_gift_aid.Checked              + "</gift_aid>"                 +
                    (txt_first_name.Text            != "" ? "<first_name>"              + txt_first_name.Text               + "</first_name>"               : "") +
                    (txt_last_name.Text             != "" ? "<last_name>"               + txt_last_name.Text                + "</last_name>"                : "") +
                    (txt_address1.Text              != "" ? "<address1>"                + txt_address1.Text                 + "</address1>"                 : "") +
                    (txt_address2.Text              != "" ? "<address2>"                + txt_address2.Text                 + "</address2>"                 : "") +
                    (txt_town.Text                  != "" ? "<town>"                    + txt_town.Text                     + "</town>"                     : "") +
                                                            "<overseas>"                + chk_overseas.Checked              + "</overseas>"                 +
                    (txt_post_code.Text             != "" ? "<post_code>"               + txt_post_code.Text                + "</post_code>"                : "") +
                    (ddl_payment_type.SelectedValue != "" ? "<payment_type>"            + ddl_payment_type.SelectedValue    + "</payment_type>"             : "") +
                                                            "<accept_t_c>"              + chk_accept_t_c.Checked            + "</accept_t_c>"               +
                    (txt_successfulReturnURL.Text   != "" ? "<successfulReturnURL>"     + txt_successfulReturnURL.Text      + "</successfulReturnURL>"      : "") +
                    (txt_unsuccessfulReturnURL.Text != "" ? "<unsuccessfulReturnURL>"   + txt_unsuccessfulReturnURL.Text    + "</unsuccessfulReturnURL>"    : "");
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text                        = ConfigurationManager.AppSettings["APIKey"].ToString();
            txt_user_id.Text                        = ConfigurationManager.AppSettings["UserID"].ToString();
            txt_tribute_id.Text                     = "";
            chk_donation_online.Checked             = true;
            chk_anonymous.Checked                   = false;
            chk_anonymous_report.Checked            = false;
            txt_display_name.Text                   = "Test Donation";
            txt_message.Text                        = "Testing donations via api";
            txt_email.Text                          = "test@tester.com";
            txt_ip.Text                             = "27.0.0.1";
            txt_donation.Text                       = "1";
            chk_hide_donation_value.Checked         = false;
            chk_gift_aid.Checked                    = true;
            txt_first_name.Text                     = "Test";
            txt_last_name.Text                      = "Tester";
            txt_address1.Text                       = "1 Some Address";
            txt_address2.Text                       = "Some Place";
            txt_town.Text                           = "Some Town";
            chk_overseas.Checked                    = false;
            txt_post_code.Text                      = "S12 1AA";
            ddl_payment_type.SelectedValue          = "MASTERCARD_DEBIT";
            chk_accept_t_c.Checked                  = true;
            txt_successfulReturnURL.Text            = "https://www.yourdomain.co.uk/custom_page?success=true";
            txt_unsuccessfulReturnURL.Text          = "https://www.yourdomain.co.uk/custom_page?success=false";
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                //Response.Redirect(responseNode["Data"].InnerText);
                id.Text                             = responseNode["Data"]["id"].InnerText;
                tribute_id.Text                     = responseNode["Data"]["tribute_id"].InnerText;
                anonymous.Text                      = responseNode["Data"]["anonymous"].InnerText;
                display_name.Text                   = responseNode["Data"]["display_name"].InnerText;
                message.Text                        = responseNode["Data"]["message"].InnerText;
                donation.Text                       = responseNode["Data"]["donation"].InnerText;
                donation_online.Text                = responseNode["Data"]["donation_online"].InnerText;
                gift_aid.Text                       = responseNode["Data"]["gift_aid"].InnerText;
                date_donation.Text                  = responseNode["Data"]["date_donation"].InnerText;
                value_gift_aid.Text                 = responseNode["Data"]["value_gift_aid"].InnerText;
                
                if (responseNode["Data"]["PaymentGatewayURL"] != null)
                {
                    string PaymentGatewayURL            = responseNode["Data"]["PaymentGatewayURL"].InnerText;
                    hpl_PaymentGatewayURL.Text          =
                    hpl_PaymentGatewayURL.NavigateUrl   = PaymentGatewayURL;
                    hpl_PaymentGatewayURL.Enabled       = true;
                }
                else
                {
                    hpl_PaymentGatewayURL.Text          = "NA";
                    hpl_PaymentGatewayURL.NavigateUrl   = "";
                    hpl_PaymentGatewayURL.Enabled       = false;
                }
                bool hide_donation_val              = Convert.ToBoolean(responseNode["Data"]["hide_donation_value"].InnerText);
                hide_donation_value.Text            = hide_donation_val.ToString();

                if (hide_donation_val)
                {
                    donation.Text                   += "(Donor has chosen to hide donation value)";
                    value_gift_aid.Text             += "(Donor has chosen to hide donation value)";
                }

                ResultPanel.Visible                 = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }
    }
}