﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class donationResponse : System.Web.UI.Page
    {
        protected string Data
        {
            get
            {
                return string.Format("{0}={1}&cartId={2}&hide_donation_value={3}&donation={4}&status={5}&gift_aid={6}&gift_aid_value={7}&anonymous={8}&display_name={9}&message={10}&donation_online={11}&date_donation={12}"
                                        ,txt_donationResponseAccessKey.Text
                                        ,txt_donationResponseAccessValue.Text
                                        ,txt_cartId.Text
                                        ,chk_hide_donation_value.Checked
                                        ,txt_donation.Text
                                        ,ddl_status.SelectedValue
                                        ,chk_gift_aid.Checked
                                        ,txt_gift_aid_value.Text
                                        ,chk_anonymous.Checked
                                        ,HttpUtility.UrlEncode(txt_display_name.Text)
                                        ,HttpUtility.UrlEncode(txt_message.Text)
                                        ,chk_donation_online.Checked
                                        ,HttpUtility.UrlEncode(txt_date_donation.Text));
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_donationResponseURL.Text            = "YOUR_DONATION_RESPONSE_URL";
            txt_donationResponseAccessKey.Text      = "YOUR_ACCESS_KEY";
            txt_donationResponseAccessValue.Text    = "YOUR_ACCESS_VALUE";
            txt_cartId.Text                         = "MG-T99999-D9999";
            chk_hide_donation_value.Checked         = true;
            txt_donation.Text                       = "10";
            ddl_status.SelectedValue                = "success";                               
            chk_gift_aid.Checked                    = true;
            txt_gift_aid_value.Text                 = "2.38";
            chk_anonymous.Checked                   = true;
            txt_display_name.Text                   = "TEST DONATION";
            txt_message.Text                        = "TEST MESSAGE";
            chk_donation_online.Checked             = true;
            txt_date_donation.Text                  = DateTime.Now.ToString("dd MMM yyyy HH:mm:ss");
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                XmlDocument xmlResponse = HttpRequest.MakeRequest(txt_donationResponseURL.Text, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorInternalMessage.Text = ex.Message;
                

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorInternalMessage.Text   = "An Error occured while trying to make a donation response.";

                ErrorPanel.Visible          = true;
            }
        }

    }
}